#pragma once
#include "shoes.h"
//#include "Lgrader.cpp"
#include <iostream>
#include <vector>
using namespace std;


bool DEBUG = false;


pair<vector<int>, vector<int>> splitShoes(vector<int>& shoes);
int find(vector<int>& vec, int element);
void moveFromTo(pair<vector<int>, vector<int>>& split_shoes);


vector<pair<int, int>> pairs;


vector<pair<int, int>> guessPairs(int n) {
	pairs.clear();
	if(DEBUG) {
		cout << "Started guessing" << endl;
	}
	vector<int> shoes;
	for(int i = 1; i <= n * 2; ++i)
		shoes.push_back(i);
	
	while(!shoes.empty()) {
		int curr_shoe = shoes[0];
		shoes.erase(shoes.begin() + 0);

		vector<int> curr_shoes;
		for(int shoe : shoes) {
			curr_shoes.push_back(shoe);
		}
		
		while(curr_shoes.size() > 1) {
			auto split_shoes = splitShoes(curr_shoes);
			bool first = false, second = false;
			while((first = pairInSet(split_shoes.first)) && (second = pairInSet(split_shoes.second))) {
				moveFromTo(split_shoes);
			}
			if(first && !second)
				swap(split_shoes.first, split_shoes.second);
			split_shoes.first.push_back(curr_shoe);
			if(pairInSet(split_shoes.first)) {
				curr_shoes = split_shoes.first;
				curr_shoes.erase(curr_shoes.begin() + curr_shoes.size() - 1);
			}
			else
				curr_shoes = split_shoes.second;
		}
		if(DEBUG) {
			cout << curr_shoes.size() << endl;
		}
		pairs.push_back({curr_shoe, curr_shoes[0]});
		shoes.erase(shoes.begin() + find(shoes, curr_shoes[0]));
	}
	
	return pairs;
}


pair<vector<int>, vector<int>> splitShoes(vector<int>& shoes) {
	pair<vector<int>, vector<int>> split_shoes;
	int i;
	for(i = 0; i < shoes.size(); ++i) {
		if(i < shoes.size() / 2)
			split_shoes.first.push_back(shoes[i]);
		else
			split_shoes.second.push_back(shoes[i]);
	}
	return split_shoes;
}


void moveFromTo(pair<vector<int>, vector<int>>& split_shoes) {
	split_shoes.first.push_back(split_shoes.second[split_shoes.second.size() - 1]);
	split_shoes.second.erase(split_shoes.second.begin() + split_shoes.second.size() - 1);
}


int find(vector<int>& vec, int element) {
	for(int i = 0; i < vec.size(); ++i) {
		if(vec[i] == element)
			return i;
	}
	return -1;
}