#include<bits/stdc++.h>
using namespace std;

const int nmax=3e3+42;

int x_[4]={1,-1,0,0};
int y_[4]={0,0,1,-1};

int n,m,h,w;

char given[nmax][nmax];

int inp[nmax][nmax],col;

vector< pair<int,int> > seen={};

struct info
{
    int lazy;
    int mini=0;
    int maxi=0;
    int id;
};

info tree[4*nmax];

void build(int node,int l,int r)
{
    tree[node].id=l;

    if(l==r)return;

    int av=(l+r)/2;

    build(node*2,l,av);
    build(node*2+1,av+1,r);
}

void push(int node)
{
    tree[node*2].lazy+=tree[node].lazy;
    tree[node*2+1].lazy+=tree[node].lazy;

    tree[node].lazy=0;
}

info actual(info now)
{
    now.mini+=now.lazy;
    now.maxi+=now.lazy;
    now.lazy=0;

    return now;
}

info my_merge(info a,info b)
{
    a=actual(a);
    b=actual(b);

    a.maxi=max(a.maxi,b.maxi);
    if(a.mini>b.mini)a.mini=b.mini,a.id=b.id;

    return a;
}

void update(int node,int l,int r,int lq,int rq,int val)
{
    if(l==lq&&r==rq)
    {
        tree[node].lazy+=val;
        return;
    }

    push(node);

    int av=(l+r)/2;

    if(lq<=av)update(node*2,l,av,lq,min(av,rq),val);
    if(av<rq)update(node*2+1,av+1,r,max(av+1,lq),rq,val);

    tree[node]=my_merge(tree[node*2],tree[node*2+1]);
}

info query(int node,int l,int r,int lq,int rq)
{
    if(l==lq&&r==rq)return actual(tree[node]);

    push(node);

    info ret;
    ret.lazy=0;
    ret.mini=1e9;
    ret.maxi=-1e9;
    ret.id=0;

    int av=(l+r)/2;

    if(lq<=av)ret=my_merge(ret,query(node*2,l,av,lq,min(av,rq)));
    if(av<rq)ret=my_merge(ret,query(node*2+1,av+1,r,max(av+1,lq),rq));

    tree[node]=my_merge(tree[node*2],tree[node*2+1]);

    return ret;
}

void dfs(int x,int y)
{
    if(1>x||x>n||1>y||y>m)return;

    if(inp[x][y]||given[x][y]!='x')return;

    seen.push_back({x,y});

    inp[x][y]=col;

    for(int i=0;i<4;i++)
        dfs(x+x_[i],y+y_[i]);
}

vector< pair<int, pair<int,int> > > updates[nmax],final_updates[nmax];

bool cmp(pair<int, pair<int,int> > a,pair<int, pair<int,int> > b)
{
    return a.first>b.first;
}

int border_left,border_right;

int go_right(int node,int l,int r,int lq,int rq)
{
    if(actual(tree[node]).maxi==0)return rq;

    if(actual(tree[node]).mini)return lq-1;

    push(node);

    int av=(l+r)/2;

    int go=lq-1;

    if(lq<=av)
    {
        go=go_right(node*2,l,av,lq,min(av,rq));
    }

    if(av<rq&&go+1==max(av+1,lq))
    {
        go=go_right(node*2+1,av+1,r,max(av+1,lq),rq);
    }

    tree[node]=my_merge(tree[node*2],tree[node*2+1]);

    return go;
}

int go_left(int node,int l,int r,int lq,int rq)
{
    if(actual(tree[node]).maxi==0)return lq;

    if(actual(tree[node]).mini)return rq+1;

    push(node);

    int av=(l+r)/2;

    int go=rq+1;

    if(av<rq)
    {
        go=go_left(node*2+1,av+1,r,max(av+1,lq),rq);
    }

    if(lq<=av&&min(av,rq)==go-1)
    {
        go=go_left(node*2,l,av,lq,min(av,rq));
    }

    tree[node]=my_merge(tree[node*2],tree[node*2+1]);

    return go;
}

pair<int,int> get_borders(int p_f,int p_s,int mini)
{
    int le=go_left(1,1,n-h+1,p_f,mini);

    int ri=go_right(1,1,n-h+1,mini,p_s);

    return {le,ri};
}

mt19937 rng(42);

int main()
{
    scanf("%i%i%i%i",&n,&m,&h,&w);

    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            char cur=';';

            /*
            if(rng()%2)cur='.';
            else cur='x';
            */

            while(cur!='.'&&cur!='x')cur=getchar();

            given[i][j]=cur;
        }
    }

    build(1,1,n-h+1);

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            if(given[i][j]=='x'&&inp[i][j]==0)
            {
                seen={};

                col++;
                dfs(i,j);

                //cout<<"col= "<<col<<endl;

                set<int> interesting={};

                for(auto p:seen)
                {
                    int x1=max(1,p.first-h+1);
                    int y1=max(1,p.second-w+1);

                    int x2=min(n-h+1,p.first);
                    int y2=min(m-w+1,p.second);

                    //cout<<x1<<" "<<y1<<" "<<x2<<" "<<y2<<endl;

                    interesting.insert(y1);
                    interesting.insert(y2+1);

                    updates[y1].push_back({1,{x1,x2}});
                    updates[y2+1].push_back({-1,{x1,x2}});
                }

                for(auto w:interesting)
                {
                    sort(updates[w].begin(),updates[w].end(),cmp);

                    for(auto p:updates[w])
                    {
                        if(p.first>0)
                        {
                            info cur=query(1,1,n-h+1,p.second.first,p.second.second);

                            int mini=cur.id;

                            if(cur.mini==0)
                            {
                                final_updates[w].push_back({1,get_borders(p.second.first,p.second.second,mini)});
                            }

                            update(1,1,n-h+1,p.second.first,p.second.second,1);
                        }
                        else
                        {
                            update(1,1,n-h+1,p.second.first,p.second.second,-1);

                            info cur=query(1,1,n-h+1,p.second.first,p.second.second);

                            int mini=cur.id;

                            if(cur.mini==0)
                            {
                                final_updates[w].push_back({-1,get_borders(p.second.first,p.second.second,mini)});
                            }
                        }
                    }

                    updates[w]={};
                }
            }

    int outp=0;

    for(int y=1;y<=m;y++)
    {
        for(auto w:final_updates[y])
        {
            update(1,1,n-h+1,w.second.first,w.second.second,w.first);
        }

        outp=max(outp,query(1,1,n-h+1,1,n-h+1).maxi);
    }

    printf("%i\n",outp);

    return 0;
}
