#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 4000;

vector<int> X[MAXN + 5];
int a[MAXN + 5][MAXN + 5];
int dp[MAXN + 5][MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    vector<int> vx, vy;
    vector< pair<int, int> > xy;
    for (int i = 1; i <= n; ++ i)
    {
        int x, y;
        cin >> x >> y;
        xy.push_back(make_pair(x, y));
        vx.push_back(x);
        vy.push_back(y);
    }

    sort(vx.begin(), vx.end());
    auto itx = unique(vx.begin(), vx.end());
    vx.resize(distance(vx.begin(), itx));

    sort(vy.begin(), vy.end());
    auto ity = unique(vy.begin(), vy.end());
    vy.resize(distance(vy.begin(), ity));

    for (int i = 0; i < n; ++ i)
    {
        int px = lower_bound(vx.begin(), vx.end(), xy[i].first) - vx.begin();
        xy[i].first = px + 1;
        int py = lower_bound(vy.begin(), vy.end(), xy[i].second) - vy.begin();
        xy[i].second = py + 1;
        X[xy[i].first].push_back(xy[i].second);
        a[xy[i].first][xy[i].second] = 1;
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            dp[i][j] = dp[i - 1][j] + dp[i][j - 1] - dp[i - 1][j - 1] + a[i][j];
        }
    }

    int ans0 = 0;
    for (int i = 0; i < n; ++ i)
    {
        for (int j = i + 1; j < n; ++ j)
        {
            int x1 = min(xy[i].first, xy[j].first), x2 = max(xy[i].first, xy[j].first);
            int y1 = min(xy[i].second, xy[j].second), y2 = max(xy[i].second, xy[j].second);
            int t = dp[x2][y2] - dp[x1 - 1][y2] - dp[x2][y1 - 1] + dp[x1 - 1][y1 - 1];
            if (t == 2) ans0++;
        }
    }

    sort(xy.begin(), xy.end());

    int vxsz = vx.size();
    for (int i = 1; i <= vxsz; ++ i)
    {
        sort(X[i].begin(), X[i].end());
    }

    int ans = 0, ans1 = 0;
    for (int i = 0; i < n; ++ i)
    {
        int mx = +(n + 1), mn = -(n + 1);
        int x = xy[i].first, y = xy[i].second;

        int p = lower_bound(X[x].begin(), X[x].end(), y + 1) - X[x].begin();
        int ymx = (p < X[x].size() ? X[x][p] - y : +(n + 1));
        int ymn = (p > 1 ? y - X[x][p - 2] : -(n + 1));
        if (ymx < mx)
        {
            ans1++;
            mx = ymx;
        }
        if (ymn > mn)
        {
            ans1++;
            mn = ymn;
        }

        for (int j = x + 1; j <= vxsz; ++ j)
        {
            int p = lower_bound(X[j].begin(), X[j].end(), y) - X[j].begin();
            int ymx = (p < X[j].size() ? X[j][p] - y : +(n + 1));
            int ymn = (p < X[j].size() and X[j][p] == y ? 0 : (p > 0 ? y - X[j][p - 1] : -(n + 1)));
            if (ymx < mx)
            {
                ans++;
                mx = ymx;
            }
            if (ymn > mn)
            {
                if (ymn != 0) ans++;
                mn = ymn;
            }
        }
    }
    
    if (ans0 < ans + ans1 / 2) cout << -1/0 << endl;
    cout << ans + ans1 / 2 << endl;

    return 0;
}
