#include <iostream>
#include <utility>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 3000;

int cnt = 0;
int a[MAXN + 5][MAXN + 5];
vector<int> col[MAXN + 5];
bool t[MAXN + 5][MAXN + 5], used[MAXN + 5][MAXN + 5];

void BFS(int i, int j)
{
    cnt++;
    queue< pair<int, int> > q;
    q.push({i, j});
    while (!q.empty())
    {
        i = q.front().first;
        j = q.front().second;
        a[i][j] = cnt;
        q.pop();

        if (t[i - 1][j] and !used[i - 1][j])
        {
            q.push({i - 1, j});
            used[i - 1][j] = true;
        }
        if (t[i][j - 1] and !used[i][j - 1])
        {
            q.push({i, j - 1});
            used[i][j - 1] = true;
        }
        if (t[i][j + 1] and !used[i][j + 1])
        {
            q.push({i, j + 1});
            used[i][j + 1] = true;
        }
        if (t[i + 1][j] and !used[i + 1][j])
        {
            q.push({i + 1, j});
            used[i + 1][j] = true;
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, h, w;
    cin >> n >> m >> h >> w;

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            char c;
            cin >> c;

            if (c == 'x') t[i][j] = true;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            if (t[i][j] and !used[i][j]) BFS(i, j);
        }
    }

    int ans0 = 0;
    vector<int> vc(cnt + 1, 0), vc1;
    vector<int> idle(cnt + 1, 0);
    for (int j = 1; j <= m; ++ j)
    {
        col[j] = idle;
        for (int i = 1; i <= h; ++ i)
        {
            if (!a[i][j]) continue;
            col[j][a[i][j]]++;
            if (j <= w)
            {
                if (vc[a[i][j]] == 0) ans0++;
                vc[a[i][j]]++;
            }
        }
    }

    int ans = 0;
    for (int i = 1; i <= n - h + 1; ++ i)
    {
        int ans1 = 0;
        for (int j = 1; j <= m - w + 1; ++ j)
        {
            if (j == 1)
            {
                if (i > 1)
                {
                   for (int j1 = 1; j1 <= m; ++ j1)
                   {
                       col[j1][a[i - 1][j1]]--;
                       col[j1][a[i + h - 1][j1]]++;
                       if (j <= w)
                       {
                           if (vc[a[i - 1][j1]] == 1) ans0--;
                           vc[a[i - 1][j1]]--;
                           if (vc[a[i + h - 1][j1]] == 0) ans0++;
                           vc[a[i + h - 1][j1]]++;
                       }
                   }
                }
                ans1 = ans0;
                vc1 = vc;
            }
            else
            {
                for (int t = 1; t <= cnt; ++ t)
                {
                    bool flag = false;
                    if (vc1[t] > 0) flag = true;
                    vc1[t] -= col[j - 1][t];
                    if (vc1[t] == 0 and flag) ans1--;

                    flag = false;
                    if (vc1[t] == 0) flag = true;
                    vc1[t] += col[j + w - 1][t];
                    if (vc1[t] > 0 and flag) ans1++;
                }
            }
            ans = max(ans, ans1);
        }
    }

    cout << ans << endl;

    return 0;
}
