#include <iostream>
#include <utility>
#include <queue>
#include <ctime>
#define endl '\n'
using namespace std;

const int MAXN = 3000;
const int MAXT = 20;

int cnt = 0;
int a[MAXN + 1][MAXN + 1][MAXT + 1];
int dp[MAXN + 1][MAXN + 1][MAXT + 1];
bool T[MAXN + 5][MAXN + 5], used[MAXN + 5][MAXN + 5];

void BFS(int i, int j)
{
    cnt++;
    queue< pair<int, int> > q;
    q.push({i, j});
    while (!q.empty())
    {
        i = q.front().first;
        j = q.front().second;
        a[i][j][cnt] = 1;
        q.pop();

        if (T[i - 1][j] and !used[i - 1][j])
        {
            q.push({i - 1, j});
            used[i - 1][j] = true;
        }
        if (T[i][j - 1] and !used[i][j - 1])
        {
            q.push({i, j - 1});
            used[i][j - 1] = true;
        }
        if (T[i][j + 1] and !used[i][j + 1])
        {
            q.push({i, j + 1});
            used[i][j + 1] = true;
        }
        if (T[i + 1][j] and !used[i + 1][j])
        {
            q.push({i + 1, j});
            used[i + 1][j] = true;
        }
    }
}
int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, h, w;
    cin >> n >> m >> h >> w;

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            char c;
            cin >> c;

            if (c == 'x') T[i][j] = true;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            if (T[i][j] and !used[i][j]) BFS(i, j);
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            for (int t = 1; t <= cnt; ++ t)
            {
                dp[i][j][t] = dp[i - 1][j][t] + dp[i][j - 1][t] - dp[i - 1][j - 1][t] + a[i][j][t];
            }
        }
    }

    int ans = 0;
    for (int i = 1; i <= n - h + 1; ++ i)
    {
        for (int j = 1; j <= m - w + 1; ++ j)
        {
            int ans1 = 0;
            for (int t = 1; t <= cnt; ++ t)
            {
                ans1 += min(1, dp[i + h - 1][j + w - 1][t] - dp[i - 1][j + w - 1][t] - dp[i + h - 1][j - 1][t] + dp[i - 1][j - 1][t]);
            }
            ans = max(ans, ans1);
        }
    }

    cout << ans << endl;

    return 0;
}
