#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " = " << x << " ]"

struct debug {
    debug() { cerr << "Debugger start " << endl; }
    ~debug() { cerr << endl << "Debugger end " << endl; }

    template<class T>
    debug& operator <<(const T &x) {
        cerr << x;
        return (*this);
    }
};

template<class T> inline ostream &operator <<(ostream &out, const vector<T> &x) {
    for(auto it : x) {
        out << it << " ";
    }
    return out;
}

template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {
    return out << x.first << " " << x.second;
}

template<class T, class T2> bool chkmin(T &x, const T2 &y) {
    return (x > y) ? x = y, true : false;
}
template<class T, class T2> bool chkmax(T &x, const T2 &y) {
    return (x < y) ? x = y, true : false;
}
typedef long long ll;
const ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const int MAX_N = 1e6 + 10;

struct SegTree {
    int tree[4 * MAX_N];

    void init() {
        fill_n(tree, 4 * MAX_N, 0);
    }

    void upd(int curr, int l, int r, int ind, int val) {
        if(l == r && l == ind) {
            tree[curr] += val;
            return;
        } else if(l > ind || r < ind) {return;}
        int m = (l + r) / 2ll;
        upd(curr * 2, l, m, ind, val);
        upd(curr * 2 + 1, m + 1, r, ind, val);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }

    ll sum(int curr, int l, int r, int ql, int qr) {
        if(r < l) {return 0;}
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(l > qr || r < ql) {
            return 0;
        }
        int m = (l + r) / 2ll;
        return sum(curr * 2, l, m, ql, qr) + sum(curr * 2 + 1, m + 1, r, ql, qr);
    }
};

SegTree open, blocked_by;

pair<int, int> p[MAX_N];
int n;
vector<int> who[MAX_N];

void slow() {
    ll ret = 0;
    for(int i = 0; i < 2 * n; i ++) {
        multiset<int> st;
        st.insert(-mod);
        st.insert(mod);

        for(int j = i + 1; j < 2 * n; j ++) {
            for(auto it : who[j]) {
                st.insert(it);
            }

            for(auto it : who[j]) {
                st.erase(st.find(it));

                for(auto old : who[i]) {
                    if(old <= it) {
                        auto fff = st.upper_bound(it);
                        fff --;

                        if(*fff < old) {
                            ret ++;
                        }
                    } else {
                        auto fff = st.lower_bound(it);

                        if(*fff > old) {
                            ret ++;
                        }
                    }
                }

                st.insert(it);
            }
        }
    }
    cout << ret << endl;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    vector<int> c;

    cin >> n;
    for(int i = 0; i < n; i ++) {
        cin >> p[i].first >> p[i].second;
        c.push_back(p[i].first);
        c.push_back(p[i].second);
    }
    sort(p, p + n);
    sort(c.begin(), c.end());

    for(int i = 0; i < n; i ++) {
        p[i].first = lower_bound(c.begin(), c.end(), p[i].first) - c.begin();
        p[i].second = lower_bound(c.begin(), c.end(), p[i].second) - c.begin();

        who[p[i].first].push_back(p[i].second);
    }

    for(int i = 0; i < 2 * n; i ++) {
        sort(who[i].begin(), who[i].end());
    }

    slow();

    return 0;
}

