#include <bits/stdc++.h>
using namespace std;
#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " = " << x << " ]"

struct debug {
    debug() { cerr << "Debugger start " << endl; }
    ~debug() { cerr << endl << "Debugger end " << endl; }

    template<class T>
    debug& operator <<(const T &x) {
        cerr << x;
        return (*this);
    }
};

template<class T> inline ostream &operator <<(ostream &out, const vector<T> &x) {
    for(auto it : x) {
        out << it << " ";
    }
    return out;
}

template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {
    return out << x.first << " " << x.second;
}

template<class T, class T2> bool chkmin(T &x, const T2 &y) {
    return (x > y) ? x = y, true : false;
}
template<class T, class T2> bool chkmax(T &x, const T2 &y) {
    return (x < y) ? x = y, true : false;
}
typedef long long ll;
const ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const int MAX_N = 3e3 + 10;
short tab[MAX_N][MAX_N];
string str[MAX_N];
int n, m, h, w;

void dfs(int x, int y, int comp) {
    if(x < 0 || y < 0 || x >= n || y >= m || tab[x][y] != 0) {return;}
    if(str[x][y] == '.') {return;}
    tab[x][y] = comp;
    dfs(x - 1, y, comp);
    dfs(x + 1, y, comp);
    dfs(x, y - 1, comp);
    dfs(x, y + 1, comp);
}

short ans[MAX_N][MAX_N];
short pref[MAX_N][MAX_N];

ll getSum(ll x, ll y, ll xx, ll yy) {
    ll ret = pref[xx][yy];

    if(x != 0) {
        ret -= pref[x - 1][yy];
    }
    if(y != 0) {
        ret -= pref[xx][y - 1];
    }
    if(x != 0 && y != 0) {
        ret += pref[x - 1][y - 1];
    }
    return ret;
}

void apply(int x) {
    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < m; j ++) {
            pref[i][j] = (tab[i][j] == x);

            if(i != 0) {
                pref[i][j] += pref[i - 1][j];
            }
            if(j != 0) {
                pref[i][j] += pref[i][j - 1];
            }
            if(i != 0 && j != 0) {
                pref[i][j] -= pref[i - 1][j - 1];
            }
        }
    }

    for(int i = 0; i + h <= n; i ++) {
        for(int j = 0; j + w <= m; j ++) {
            if(getSum(i, j, i + h - 1, j + w - 1) > 0) {
                ans[i][j] ++;
            }
        }
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n >> m >> h >> w;
    for(int i = 0; i < n; i ++) {
        str[i].resize(m);
        for(int j = 0; j < m; j ++) {
            cin >> str[i][j];
        }
    }

    int cnt = 1;

    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < m; j ++) {
            if(str[i][j] == 'x' && tab[i][j] == 0) {
                dfs(i, j, cnt);
                cnt ++;
            }
        }
    }

    for(int i = 1; i < cnt; i ++) {
        apply(i);
    }

    ll ret = 0;
    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < m; j ++) {
            chkmax(ret, ans[i][j]);
        }
    }

    cout << ret << endl;

    return 0;
}


