#include <iostream>
#include <algorithm>
#include <vector>

typedef long long llong;
const int maxn = 300000 + 10;
const int inf = 1e9;

struct Point
{
    int x, y;
    inline friend bool operator < (Point a, Point b)
    {
        return a.x < b.x || (a.x == b.x && a.y < b.y);
    }

} p[maxn];

int lower[maxn], upper[maxn], n;
int rightmost[maxn];

void solve()
{
    std::sort(p+1, p+1+n);
    std::fill(upper+1, upper+1+n, inf);
    std::fill(lower+1, lower+1+n, -inf);
    llong ans = 0, curr = n;

    for (int i = n ; i >= 1 ; --i)
    {
        if (p[i].x != p[i+1].x) curr = i;
        rightmost[i] = curr;
    }

    // std::cout << "sorted\n";
    // for (int i = 1 ; i <= n ; ++i)
    // {
    //     std::cout << p[i].x << ' ' << p[i].y << '\n';
    // }

    for (int i = n-1 ; i >= 1 ; --i)
    {
        // std::cout << "i: " << i << ' ' << p[i].x << ' ' << p[i].y << '\n';
        for (int j = i+1 ; j <= n ; ++j)
        {
            // std::cout << "j: " << j << ' ' << (p[i].y >= p[j].y) << ' ' << upper[j] << ' ' << lower[j] << '\n';
            if (p[i].y >= p[j].y && upper[j] > p[i].y) ++ans/*, std::cout << "1++\n"*/;
            else if (p[i].y < p[j].y && lower[j] < p[i].y) ++ans/*, std::cout << "2++\n"*/;
        }

        for (int j = i+1 ; j <= n ; ++j)
        {
            if (p[i].y <= p[j].y) lower[j] = std::max(lower[j], p[i].y);
            if (p[i].y >= p[j].y) upper[j] = std::min(upper[j], p[i].y);
        }

        for (int j = i+1 ; j <= rightmost[i] ; ++j)
        {
            if (i == j) continue;
            if (p[j].y <= p[i].y) lower[i] = std::max(lower[i], p[j].y);
            if (p[j].y >= p[i].y) upper[i] = std::min(upper[i], p[j].y);
        }

        // std::cout << "ans: " << ans << '\n';
    }

    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> p[i].x >> p[i].y;
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}