#include <iostream>
#include <algorithm>
#include <vector>
#define int long long

typedef long long llong;
const int maxn = 300000 + 10;
const int inf = 2e9;

struct Point
{
    int x, y;
    inline friend bool operator < (Point a, Point b)
    {
        return a.x < b.x || (a.x == b.x && a.y < b.y);
    }

} p[maxn];

int lower[maxn], upper[maxn], n;
int lowerCnt[maxn], upperCnt[maxn];
int leftmost[maxn];

void solve()
{
    std::sort(p+1, p+1+n);
    std::fill(upper+1, upper+1+n, inf);
    std::fill(lower+1, lower+1+n, -inf);
    llong ans = 0;

    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = i+1 ; j <= n ; ++j)
        {
            bool bl = 1;
            int minX = std::min(p[i].x, p[j].x);
            int maxX = std::max(p[i].x, p[j].x);
            int minY = std::min(p[i].y, p[j].y);
            int maxY = std::max(p[i].y, p[j].y);
            for (int x = 1 ; x <= n && bl ; ++x)
            {
                if (i == x || j == x) continue;
                bl &= !(minX <= p[x].x && p[x].x <= maxX && minY <= p[x].y && p[x].y <= maxY);
            }

            ans += bl;
        }
    }

    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> p[i].x >> p[i].y;
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fastIO();
    read();
    solve();

    return 0;
}