#include <iostream>
#include <algorithm>
#include <vector>
#define int long long

typedef long long llong;
const int maxn = 300000 + 10;
const int inf = 2e9;

struct Point
{
    int x, y;
    inline friend bool operator < (Point a, Point b)
    {
        return a.x < b.x || (a.x == b.x && a.y < b.y);
    }

} p[maxn];

int lower[maxn], upper[maxn], n;
int lowerCnt[maxn], upperCnt[maxn];
int leftmost[maxn];

void solve()
{
    std::sort(p+1, p+1+n);
    std::fill(upper+1, upper+1+n, inf);
    std::fill(lower+1, lower+1+n, -inf);
    llong ans = 0, curr = 1;

    for (int i = 1 ; i <= n ; ++i)
    {
        if (p[i].x != p[i-1].x) curr = i;
        leftmost[i] = curr;
    }

    std::cout << "sorted\n";
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << p[i].x << ' ' << p[i].y << '\n';
    }

    int p1 = n;
    for (int i = n ; i >= 1 ; --i)
    {
        int curr = 0;
        if (i == p1)
        {
            for (int x = p1 ; x >= leftmost[p1] ; --x)
            {
                for (int j = leftmost[p1] ; j <= n ; ++j)
                {
                    if (x == j) continue;
                    // if (x == 20 && j == 19) std::cout << "here" << p[x].y << ' ' << p[j].y << ' ' << lower[j] << ' ' << upper[j] << '\n';
                    if (p[x].y <= p[j].y) 
                    {
                        if (lower[j] == p[x].y) ++lowerCnt[j];
                        if (lower[j] < p[x].y)
                        {
                            lower[j] = p[x].y;
                            lowerCnt[j] = 1;
                        }
                    }
                    if (p[x].y >= p[j].y) 
                    {
                        if (upper[j] == p[x].y) ++upperCnt[j];
                        if (upper[j] > p[x].y)
                        {
                            upper[j] = p[x].y;
                            upperCnt[j] = 1;
                        }
                    }
                }
            }
            
            p1 = leftmost[p1]-1;
        }
        // std::cout << "i: " << i << ' ' << p[i].x << ' ' << p[i].y << '\n';
        curr = -ans;
        for (int j = i+1 ; j <= n ; ++j)
        {
            // std::cout << "j: " << j << ' ' << (p[i].y >= p[j].y) << ' ' << upper[j] << ' ' << lower[j] << '\n';
            if (p[i].y >= p[j].y && (upper[j] > p[i].y || (upper[j] == p[i].y && upperCnt[j] == 1))) ++ans/*, std::cout << "1++\n"*/;
            else if (p[i].y < p[j].y && (lower[j] < p[i].y || (lower[j] == p[i].y && lowerCnt[j] == 1))) ++ans/*, std::cout << "2++\n"*/;
        }
        curr += ans;

        // std::cout << "ans: " << i << ' ' << curr << '\n';
    }

    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> p[i].x >> p[i].y;
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fastIO();
    read();
    solve();

    return 0;
}