#include <iostream>
#include "shoes.h"
const int maxn = 5000 + 10;

std::vector < int > left, right, curr, curr2;
std::vector < std::pair < int, int > > ans;

bool check(int l, int r, const std::vector < int > &val)
{
    curr2.clear();
    for (int i : val) curr2.push_back(i);
    for (int i = l ; i <= r ; ++i) curr2.push_back(left[i]);
    
    return pairInSet(curr2);
}

std::vector < std::pair < int, int > > waiting, waiting2;
std::vector < int > tree[4*maxn];

void recurse(int l, int r, int node)
{
    // std::cout << "l, r: " << l << ' ' << r << '\n';
    // for (int i : tree[node]) std::cout << i << ' ';
    // std::cout << '\n';

    if (l == r)
    {
        ans.push_back({left[l], tree[node][0]});
        return;
    }

    if (l == r - 1)
    {
        int first = tree[node][0];
        int second = tree[node][1];
        curr.clear();
        curr.push_back(first);
        if (check(l, l, curr))
        {
            // std::cout << "first is in the left half\n";
            tree[2*node].push_back(first);
            tree[2*node+1].push_back(second);
        } else
        {
            // std::cout << "second is in the left half\n";
            tree[2*node+1].push_back(first);
            tree[2*node].push_back(second);
        }

        recurse(l, l, 2*node);
        recurse(r, r, 2*node+1);
        return;
    }

    int mid = (l+r)/2;
    for (int i = 0 ; i < tree[node].size() ; i += 2)
    {
        if (i == tree[node].size()-1)
        {
            curr.clear();
            curr.push_back(tree[node][i]);
            if (check(l, mid, curr)) tree[2*node].push_back(tree[node][i]);
            else tree[2*node+1].push_back(tree[node][i]);
        } else
        {
            curr.clear();
            curr.push_back(tree[node][i]); 
            curr.push_back(tree[node][i+1]); 
            if (!check(l, mid, curr)) 
            {
                tree[2*node+1].push_back(tree[node][i]);
                tree[2*node+1].push_back(tree[node][i+1]);
            } else
            {
                waiting.push_back({tree[node][i], tree[node][i+1]});
            }
        }
    }

    while (tree[2*node].size() != mid - l + 1 && !waiting.empty())
    {
        int first = waiting.back().first;
        int second = waiting.back().second;
        waiting.pop_back();
        // std::cout << "waiting: " << first << ' ' << second << '\n';
        curr.clear();
        curr.push_back(first);
        curr.push_back(second);
        if (!check(mid+1, r, curr))
        {
            tree[2*node].push_back(first);
            tree[2*node].push_back(second);
        } else
        {
            waiting2.push_back({first, second});
        }
    }

    while (tree[2*node+1].size() != r - mid && tree[2*node].size() != mid - l + 1 && !waiting2.empty())
    {
        int first = waiting2.back().first;
        int second = waiting2.back().second;
        // std::cout << "waiting2: " << first << ' ' << second << '\n';
        waiting2.pop_back();
        curr.clear();
        curr.push_back(first);
        if (check(l, mid, curr))
        {
            // std::cout << "first is in the left half\n";
            tree[2*node].push_back(first);
            tree[2*node+1].push_back(second);
        } else
        {
            // std::cout << "second is in the left half\n";
            tree[2*node+1].push_back(first);
            tree[2*node].push_back(second);
        }
    }

    // std::cout << "reached edge cases\n";
    if (tree[2*node+1].size() == r - mid)
    {
        while (!waiting.empty())
        {
            int first = waiting.back().first;
            int second = waiting.back().second;
            waiting.pop_back();
            tree[2*node].push_back(first);
            tree[2*node].push_back(second);
        }

        while (!waiting2.empty())
        {
            int first = waiting2.back().first;
            int second = waiting2.back().second;
            waiting2.pop_back();
            tree[2*node].push_back(first);
            tree[2*node].push_back(second);
        }
    }

    if (tree[2*node].size() == l - mid + 1)
    {
        while (!waiting.empty())
        {
            int first = waiting.back().first;
            int second = waiting.back().second;
            waiting.pop_back();
            tree[2*node+1].push_back(first);
            tree[2*node+1].push_back(second);
        }

        while (!waiting2.empty())
        {
            int first = waiting2.back().first;
            int second = waiting2.back().second;
            waiting2.pop_back();
            tree[2*node+1].push_back(first);
            tree[2*node+1].push_back(second);
        }
    }

    recurse(l, mid, 2*node);
    recurse(mid+1, r, 2*node+1);
}

std::vector < std::pair < int, int > > guessPairs(int n)
{
    left.clear();
    right.clear();
    ans.clear();
    for (int i = 0 ; i < 4*maxn ; ++i) tree[i].clear();

    left.push_back(1);
    for (int i = 2 ; i <= 2*n ; ++i)
    {
        curr.clear();
        curr.push_back(i);
        if ((right.size() == n) || (left.size() <= n-1 && !check(0, left.size()-1, curr))) left.push_back(i);
        else right.push_back(i);
    }

    // std::cout << "left:";
    // for (int i : left) std::cout << ' ' << i;
    // std::cout << '\n';

    // std::cout << "right:";
    // for (int i : right) std::cout << ' ' << i;
    // std::cout << '\n';

    for (int i : right)
    {
        tree[1].push_back(i);
    }

    recurse(0, n-1, 1);
    return ans;
} 