#include <iostream>
#include <algorithm>
#include <numeric>
#include "shoes.h"
const int maxn = 5000 + 10;

std::vector < int > st, curr;
std::vector < std::pair < int, int > > ans;

bool check(int l, int r, int val)
{
    curr.clear();
    curr.push_back(val);
    for (int i = l ; i <= r ; ++i) curr.push_back(st[i]);
    return pairInSet(curr);
}

void binary(int x)
{
    int l = 0, r = st.size() - 2, mid;
    while (l <= r)
    {
        mid = (l + r) / 2;
        if (!check(l, mid, x)) l = mid + 1;
        else r = mid - 1;
    }
    ans.push_back({x, st[l]});
    std::swap(st[l], st.back());
    st.pop_back();
}

int perm1[2*maxn];
std::vector < std::pair < int, int > > guessPairs(int n)
{
    st.clear();
    ans.clear();

    std::iota(perm1+1, perm1+1+2*n, 1);
    std::random_shuffle(perm1+1, perm1+2*n);

    for (int i = 1 ; i <= 2*n ; ++i)
    {
        // std::cout << "st:\n";
        // for (int i : st) std::cout << i << ' ';
        // std::cout << '\n';
        // std::cout << "i: " << i << ' ' << st.size() << ' ' << (st.empty() ? -1 : check(0, st.size()-1, i)) << '\n'; 
        if (st.empty()) st.push_back(perm1[i]);
        else
        {
            if (st.size() <= n-1 && !check(0, st.size()-1, perm1[i])) st.push_back(perm1[i]);
            else binary(perm1[i]);
        }
    }

    return ans;
} 