#include <iostream>
#include <algorithm>
#include <vector>
#define int long long

typedef long long llong;
const int maxn = 3000 + 10;
const int inf = 2e9;

int n, m, h, w;
char t[maxn][maxn];
int a[maxn][maxn];
std::pair < int, int > delta[] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};

int numb;
void dfs(int x, int y)
{
    a[x][y] = numb;
    for (auto [dx, dy] : delta)
    {
        if (t[x + dx][y + dy] == 'x' && !a[x + dx][y + dy])
        {
            dfs(x + dx, y + dy);
        }
    }
}

int cnt[maxn*maxn], diff;

void addCol(int col, int from, int to)
{
    for (int i = from ; i <= to ; ++i)
    {
        ++cnt[a[i][col]];
        if (cnt[a[i][col]] == 1) ++diff;
    }
}

void remCol(int col, int from, int to)
{
    for (int i = from ; i <= to ; ++i)
    {
        --cnt[a[i][col]];
        if (cnt[a[i][col]] == 0) --diff;
    }
}

int calc(int r, int c)
{
    int ans = 0;
    for (int i = 1 ; i <= numb ; ++i) cnt[i] = 0;
    for (int i = 1 ; i <= n - r + 1; ++i)
    {
        for (int j = 1 ; j <= c ; ++j)
        {
            addCol(j, i, i + r - 1);
        }

        for (int j = c ; j <= m ; ++j)
        {
            ans = std::max(ans, diff);
            if (j != m) addCol(j+1, i, i + r - 1);
            remCol(j - c + 1, i, i + r - 1);
        }

        for (int j = m - c + 2 ; j <= m ; ++j)
        {
            remCol(j, i, i + r - 1);
        }
    }

    return ans;
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            if (t[i][j] == 'x' && !a[i][j])
            {
                ++numb;
                dfs(i, j);
            }
        }
    }

    std::cout << calc(h, w) - 1 << '\n';
}

void read()
{
    std::cin >> n >> m >> h >> w;
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            std::cin >> t[i][j];
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fastIO();
    read();
    solve();

    return 0;
}