#include <iostream>
#include <algorithm>
#include <vector>
#define int long long

typedef long long llong;
const int maxn = 3000 + 10;
const int maxClans = 400 + 10;
const int inf = 2e9;

int n, m, h, w;
int byCol[maxn][maxClans];
char t[maxn][maxn];
int a[maxn][maxn];
std::pair < int, int > delta[] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};

int numb;
void dfs(int x, int y)
{
    a[x][y] = numb;
    for (auto [dx, dy] : delta)
    {
        if (t[x + dx][y + dy] == 'x' && !a[x + dx][y + dy])
        {
            dfs(x + dx, y + dy);
        }
    }
}

int cnt[maxClans], diff;
void addCol(int col)
{
    for (int i = 1 ; i <= numb ; ++i)
    {
        if (byCol[col][i] && cnt[i] == 0) ++diff;
        cnt[i] += byCol[col][i];
    }
}

void remCol(int col)
{
    for (int i = 1 ; i <= numb ; ++i)
    {
        cnt[i] -= byCol[col][i];
        if (byCol[col][i] && cnt[i] == 0) --diff;
    }
}

int calc(int r, int c)
{
    int ans = 0;
    for (int i = 1 ; i <= numb ; ++i) cnt[i] = 0;
    for (int i = 1 ; i <= m ; ++i)
    {
        for (int j = 1 ; j <= r ; ++j)
        {
            ++byCol[i][a[j][i]];
        }
    }
    
    for (int i = 1 ; i <= n - r + 1; ++i)
    {
        
        for (int j = 1 ; j <= c ; ++j)
        {
            addCol(j);
        }

        for (int j = c ; j <= m ; ++j)
        {
            ans = std::max(ans, diff);
            if (j != m) addCol(j+1);
            remCol(j - c + 1);
        }

        for (int j = m - c + 2 ; j <= m ; ++j)
        {
            remCol(j);
        }

        for (int j = 1 ; j <= m ; ++j)
        {
            --byCol[j][a[i][j]];
            ++byCol[j][a[i + r][j]];
        }
    }

    return ans;
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            if (t[i][j] == 'x' && !a[i][j])
            {
                ++numb;
                dfs(i, j);
            }
        }
    }

    std::cout << calc(h, w) << '\n';
}

void read()
{
    std::cin >> n >> m >> h >> w;
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            std::cin >> t[i][j];
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fastIO();
    read();
    solve();

    return 0;
}