#include <iostream>
#include <algorithm>
#include <vector>

typedef long long llong;
const int maxn = 3000 + 10;
const int maxClans = 400 + 10;
const int inf = 2e9;

const int BUFF_SIZE = 1e5;
int buffPos = BUFF_SIZE - 1;
char buff[BUFF_SIZE];

inline void readChar()
{
    if (++buffPos == BUFF_SIZE) fread(buff, BUFF_SIZE, 1, stdin), buffPos = 0;
}

inline void readInt(int &num)
{
    num = 0;
    for (; '0' > buff[buffPos] || buff[buffPos] > '9'; readChar());
    for (; '0' <= buff[buffPos] && buff[buffPos] <= '9'; readChar())
        num = 10*num + buff[buffPos] -'0';
}

inline void readString(char s[])
{
    int len = 0;
    for (; buff[buffPos] != ' ' && buff[buffPos] != 'x' && buff[buffPos] != '.' ; readChar());
    for (; buff[buffPos] == ' ' || buff[buffPos] == 'x' || buff[buffPos] == '.' ; readChar())
        s[len++] = buff[buffPos];
}

int n, m, h, w;
int byCol[maxn][maxClans];
char t[maxn][maxn];
int a[maxn][maxn];
std::pair < int, int > delta[] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};

int numb;
void dfs(int x, int y)
{
    a[x][y] = numb;
    for (auto [dx, dy] : delta)
    {
        if (t[x + dx][y + dy] == 'x' && !a[x + dx][y + dy])
        {
            dfs(x + dx, y + dy);
        }
    }
}

int cnt[maxClans], diff;
inline void addCol(int col)
{
    for (int i = 1 ; i <= numb ; ++i)
    {
        if (byCol[col][i] && cnt[i] == 0) ++diff;
        cnt[i] += byCol[col][i];
    }
}

inline void remCol(int col)
{
    for (int i = 1 ; i <= numb ; ++i)
    {
        cnt[i] -= byCol[col][i];
        if (byCol[col][i] && cnt[i] == 0) --diff;
    }
}

int calc(int r, int c)
{
    int ans = 0;
    for (int i = 1 ; i <= numb ; ++i) cnt[i] = 0;
    for (int i = 1 ; i <= m ; ++i)
    {
        for (int j = 1 ; j <= r ; ++j)
        {
            ++byCol[i][a[j][i]];
        }
    }
    
    for (int i = 1 ; i <= n - r + 1; ++i)
    {
        
        for (int j = 1 ; j <= c ; ++j)
        {
            addCol(j);
        }

        for (int j = c ; j <= m ; ++j)
        {
            ans = std::max(ans, diff);
            if (j != m) addCol(j+1);
            remCol(j - c + 1);
        }

        for (int j = m - c + 2 ; j <= m ; ++j)
        {
            remCol(j);
        }

        for (int j = 1 ; j <= m ; ++j)
        {
            --byCol[j][a[i][j]];
            ++byCol[j][a[i + r][j]];
        }
    }

    return ans;
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            if (t[i][j] == 'x' && !a[i][j])
            {
                ++numb;
                dfs(i, j);
            }
        }
    }

    std::cout << calc(h, w) << '\n';
}

char s[2*maxn];
void read()
{
    readInt(n);
    readInt(m);
    readInt(h);
    readInt(w);
    for (int i = 1 ; i <= n ; ++i)
    {
        readString(s);
        for (int j = 1 ; j <= m ; ++j)
        {
            t[i][j] = s[2*(j-1)];
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fastIO();
    read();
    solve();

    return 0;
}